function  im_out   =  LPCA_IS_fast( im, PCA_idx, par, s_idx, seg, A, flag, Tau, Arr, Wei, ang_idx )
[h w ch]   =   size(im);

b          =   par.win;
b2         =   b*b;
k          =   0;
s          =   par.step;

N     =  h-b+1;
M     =  w-b+1;
r     =  [1:s:N];
r     =  [r r(end)+1:N];
c     =  [1:s:M];
c     =  [c c(end)+1:M];
X     =  zeros(b*b,N*M,'single');
X_m   =  zeros(b*b,length(r)*length(c),'single');
for i  = 1:b
    for j  = 1:b
        k    =  k+1;
        blk  =  im(i:h-b+i,j:w-b+j);
        X(k,:) =  blk(:)';            
    end
end

% Compute the mean blks
idx      =   s_idx(seg(1)+1:seg(2));
set      =   1:size(X_m,2);
set(idx) =   [];

for i = 1:par.nblk
   v            =  Wei(i,set);
   X_m(:,set)   =  X_m(:,set) + X(:, Arr(i, set)) .*v(ones(b2,1), :);
end


ind         =   zeros(N,M);
ind(r,c)    =   1;
X           =   X(:, ind~=0);

N           =   length(r);
M           =   length(c);
L           =   N*M;
Y           =   zeros( b2, L );


% Smooth blocks

tau         =   par.tau;
if  flag==1
   tau    =  Tau(:, idx); 
end
Y(:, idx)    =   A'*soft( A*X(:,idx), tau );

for   i  = 2:length(seg)-1
   
    idx  =  s_idx(seg(i)+1:seg(i+1));
    
    cls  =  PCA_idx(idx(1));
    angle = ang_idx(idx(1));
    PCA_D0 = par.PCA_D0(:,2:end);
    PCA_D30 = par.PCA_D30(:,2:end);
    PCA_D60 = par.PCA_D60(:,2:end);
    PCA_D90 = par.PCA_D90(:,2:end);
    PCA_D120 = par.PCA_D120(:,2:end);
    PCA_D150 = par.PCA_D150(:,2:end);
    if angle==0
       P    =   reshape(PCA_D0(:, cls), b2, b2);
        
    elseif angle==30
       P    =   reshape(PCA_D30(:, cls), b2, b2);
    elseif angle==60
       P    =   reshape(PCA_D60(:, cls), b2, b2);
    elseif angle==90
       P    =   reshape(PCA_D90(:, cls), b2, b2);
    elseif angle==120
       P    =   reshape(PCA_D120(:, cls), b2, b2);
    elseif angle==150
       P    =   reshape(PCA_D150(:, cls), b2, b2);
    end
        
    
    tau   =  par.tau;
    if  flag==1
       tau    =  Tau(:, idx); 
    end
    Y(:, idx)    =   P'*soft(P*(X(:, idx)-X_m(:,idx)), tau) + X_m(:,idx);
end


% Output the processed image
im_out   =  zeros(h,w);
im_wei   =  zeros(h,w);
k        =  0;
for i  = 1:b
    for j  = 1:b
        k    =  k+1;
        im_out(r-1+i,c-1+j)  =  im_out(r-1+i,c-1+j) + reshape( Y(k,:)', [N M]);
        im_wei(r-1+i,c-1+j)  =  im_wei(r-1+i,c-1+j) + 1;

    end
end

im_out  =  im_out./(im_wei+eps);